<template>
  <Spinner v-if="loading"></Spinner>
  <template v-else>
    <VTable v-model:currentPage="currentPage" :data="computedData" :filters="filter" sortHeaderClass="flex items-center"
      class="w-full text-md text-left text-gray-500 dark:text-gray-300 border-t" :pageSize="10"
      @stateChanged="tableState = $event" @totalPagesChanged="totalPages = $event">
      <template #head class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
        <tr class="border-b">
          <VTh sortKey="startedAt" defaultSort="desc" class="px-6 py-3"> StartedAt </VTh>
          <VTh sortKey="stoppedAt" class="px-6 py-3"> StoppedAt </VTh>
          <th class="px-6 py-3">Status</th>
          <th class="px-6 py-3">Id</th>
        </tr>
      </template>
      <template #body="{ rows }">
        <tr v-for="row in rows" :key="row.id"
          class="border-b dark:bg-gray-800 dark:border-gray-700 hover:bg-gray-700 hover:cursor-pointer"
          @click="emit('clickRow', row)">
          <td class="px-6 py-2 font-medium text-gray-900 dark:text-white whitespace-nowrap">
            {{ datetimeFilter(row.startedAt) }}
          </td>
          <td class="px-6 py-2">
            {{ datetimeFilter(row.stoppedAt) }}
          </td>
          <td class="px-6 py-2 font-bold">
            {{ row.status }}
          </td>
          <td class="px-6 py-2">
            {{ row.id }}
          </td>
        </tr>
      </template>
    </VTable>
    <VTPagination v-model:currentPage="currentPage" :totalPages="totalPages" :boundaryLinks="true" v-if="totalPages > 1"
      class="w-full text-gray-700 mt-2 flex justify-center" />
  </template>
</template>

<style>
ul.pagination {
  display: flex;
  align-items: center;
}

ul.pagination>li {
  margin-right: 2px;
}
</style>

<script lang="ts" setup>
import { computed, ref } from "vue";

const props = defineProps(["tableData", "loading", "rowClick"]);
const computedData = computed(() => props.tableData ?? []);

const emit = defineEmits(["clickRow"]);

const currentPage = ref(1);
const totalPages = ref(0);

const filter = ref({
  default: {
    value: "",
    keys: ["id", "alias"],
  },
});

const datetimeFilter = function (value: string | undefined): string {
  if (typeof value === "undefined" || value === null) return "";

  const firstSplit = value.split("T");
  const secondSplit = firstSplit[1].split(".");
  return `${firstSplit[0]} ${secondSplit[0]}`;
};

const tableState = ref();
</script>
